/*
 * 
 * Vericon version 4.3. Generated Wed Sep 13 11:50:27 2017
 * Auto generated testbench, post edited
 *
 */
// Axi stream multiplexor testbench
// Four slave ports, one master port
// Round robin port selection.
//
// Design by G.J. van Loo, FenLogic Ltd, October-2017.
// Mail: verilog@fenlogic.com
//
// This program is free software. It comes without any guarantees or
// warranty to the extent permitted by applicable law. Although the
// author has attempted to find and correct any bugs in this free software
// program, the author is not responsible for any damage or losses of any
// kind caused by the use or misuse of the program. You can redistribute
// the program and or modify it in any form without obligations, but the
// author would appreciated if these credits stays in.
//

module axi_mux4rr_test;

localparam CLK_PERIOD=100;

localparam ADRS_BITS= 32;
localparam DATA_BITS= 32;
localparam LEN_BITS = 4;
localparam ID_BITS  = 4;
                         // Depth of the queues (FIFOs)
localparam AQ_DEPTH = 10; // Max 1K addresses
localparam DQ_DEPTH = 16; // Max 64K data 

localparam L2MEM_DEPTH = 12; // 4K words 

reg   clk;
reg   reset_n;
reg   run;
wire  done0,done1,done2,done3;
   
   
   /******************\
    *                *
    *  SLAVE PORT 0  *
    *                *
   \******************/

  // write address 
   
wire                   s0_awvalid ; 
wire                   s0_awready ; 
wire   [ADRS_BITS-1:0] s0_awaddr  ; 
wire    [LEN_BITS-1:0] s0_awlen   ; 
wire            [ 2:0] s0_awsize  ; 
wire     [ID_BITS-1:0] s0_awid    ; 
wire            [ 1:0] s0_awburst ; 
wire            [ 3:0] s0_awcache ; 
wire            [ 1:0] s0_awlock  ; 
wire            [ 2:0] s0_awprot  ; 
wire            [ 3:0] s0_awqos   ; 
                           
   // write data           
wire                   s0_wvalid  ; 
wire                   s0_wready  ; 
wire   [DATA_BITS-1:0] s0_wdata   ; 
wire            [ 3:0] s0_wstrb   ; 
wire                   s0_wlast   ; 
wire     [ID_BITS-1:0] s0_wid     ; 

   // write response    
wire                   s0_bvalid  ; 
wire                   s0_bready  ; 
wire           [ 1 :0] s0_bresp   ; 
wire     [ID_BITS-1:0] s0_bid     ; 


   //
   // read interface
   //
   
   // read address 
wire                   s0_arvalid; 
wire                   s0_arready; 
wire  [ADRS_BITS-1: 0] s0_araddr ; 
wire     [ID_BITS-1:0] s0_arid   ; 
wire    [LEN_BITS-1:0] s0_arlen  ; 
wire           [ 2: 0] s0_arsize ; 
wire           [ 1: 0] s0_arburst; 
wire           [ 3: 0] s0_arcache; 
wire           [ 1: 0] s0_arlock ; 
wire           [ 2: 0] s0_arprot ; 
wire           [ 3: 0] s0_arqos  ; 

   // read data
wire                   s0_rvalid ; 
wire                   s0_rready ; 
wire   [DATA_BITS-1:0] s0_rdata  ; 
wire                   s0_rlast  ; 
wire     [ID_BITS-1:0] s0_rid    ; 
wire           [ 1 :0] s0_rresp  ; 

  /******************\
   *                *
   *  SLAVE PORT 1  *
   *                *
  \******************/
   
   
wire                   s1_awvalid ; 
wire                   s1_awready ; 
wire   [ADRS_BITS-1:0] s1_awaddr  ; 
wire    [LEN_BITS-1:0] s1_awlen   ; 
wire            [ 2:0] s1_awsize  ; 
wire     [ID_BITS-1:0] s1_awid    ; 
wire            [ 1:0] s1_awburst ; 
wire            [ 3:0] s1_awcache ; 
wire            [ 1:0] s1_awlock  ; 
wire            [ 2:0] s1_awprot  ; 
wire            [ 3:0] s1_awqos   ; 
                           
   // write data           
wire                   s1_wvalid  ; 
wire                   s1_wready  ; 
wire   [DATA_BITS-1:0] s1_wdata   ; 
wire            [ 3:0] s1_wstrb   ; 
wire                   s1_wlast   ; 
wire     [ID_BITS-1:0] s1_wid     ; 

   // write response    
wire                   s1_bvalid  ; 
wire                   s1_bready  ; 
wire           [ 1 :0] s1_bresp   ; 
wire     [ID_BITS-1:0] s1_bid     ; 


   //
   // read interface
   //
   
   // read address 
wire                   s1_arvalid; 
wire                   s1_arready; 
wire  [ADRS_BITS-1: 0] s1_araddr ; 
wire     [ID_BITS-1:0] s1_arid   ; 
wire    [LEN_BITS-1:0] s1_arlen  ; 
wire           [ 2: 0] s1_arsize ; 
wire           [ 1: 0] s1_arburst; 
wire           [ 3: 0] s1_arcache; 
wire           [ 1: 0] s1_arlock ; 
wire           [ 2: 0] s1_arprot ; 
wire           [ 3: 0] s1_arqos  ; 

   // read data
wire                   s1_rvalid ; 
wire                   s1_rready ; 
wire   [DATA_BITS-1:0] s1_rdata  ; 
wire                   s1_rlast  ; 
wire     [ID_BITS-1:0] s1_rid    ; 
wire           [ 1 :0] s1_rresp  ; 


  /******************\
   *                *
   *  SLAVE PORT 2  *
   *                *
  \******************/
   
   
wire                   s2_awvalid ; 
wire                   s2_awready ; 
wire   [ADRS_BITS-1:0] s2_awaddr  ; 
wire    [LEN_BITS-1:0] s2_awlen   ; 
wire            [ 2:0] s2_awsize  ; 
wire     [ID_BITS-1:0] s2_awid    ; 
wire            [ 1:0] s2_awburst ; 
wire            [ 3:0] s2_awcache ; 
wire            [ 1:0] s2_awlock  ; 
wire            [ 2:0] s2_awprot  ; 
wire            [ 3:0] s2_awqos   ; 
                           
   // write data           
wire                   s2_wvalid  ; 
wire                   s2_wready  ; 
wire   [DATA_BITS-1:0] s2_wdata   ; 
wire            [ 3:0] s2_wstrb   ; 
wire                   s2_wlast   ; 
wire     [ID_BITS-1:0] s2_wid     ; 

   // write response    
wire                   s2_bvalid  ; 
wire                   s2_bready  ; 
wire           [ 1 :0] s2_bresp   ; 
wire     [ID_BITS-1:0] s2_bid     ; 


   //
   // read interface
   //
   
   // read address 
wire                   s2_arvalid; 
wire                   s2_arready; 
wire  [ADRS_BITS-1: 0] s2_araddr ; 
wire     [ID_BITS-1:0] s2_arid   ; 
wire    [LEN_BITS-1:0] s2_arlen  ; 
wire           [ 2: 0] s2_arsize ; 
wire           [ 1: 0] s2_arburst; 
wire           [ 3: 0] s2_arcache; 
wire           [ 1: 0] s2_arlock ; 
wire           [ 2: 0] s2_arprot ; 
wire           [ 3: 0] s2_arqos  ; 

   // read data
wire                   s2_rvalid ; 
wire                   s2_rready ; 
wire   [DATA_BITS-1:0] s2_rdata  ; 
wire                   s2_rlast  ; 
wire     [ID_BITS-1:0] s2_rid    ; 
wire           [ 1 :0] s2_rresp  ; 


  /******************\
   *                *
   *  SLAVE PORT 3  *
   *                *
  \******************/
   
   
wire                   s3_awvalid ; 
wire                   s3_awready ; 
wire   [ADRS_BITS-1:0] s3_awaddr  ; 
wire    [LEN_BITS-1:0] s3_awlen   ; 
wire            [ 2:0] s3_awsize  ; 
wire     [ID_BITS-1:0] s3_awid    ; 
wire            [ 1:0] s3_awburst ; 
wire            [ 3:0] s3_awcache ; 
wire            [ 1:0] s3_awlock  ; 
wire            [ 2:0] s3_awprot  ; 
wire            [ 3:0] s3_awqos   ; 
                           
   // write data           
wire                   s3_wvalid  ; 
wire                   s3_wready  ; 
wire   [DATA_BITS-1:0] s3_wdata   ; 
wire            [ 3:0] s3_wstrb   ; 
wire                   s3_wlast   ; 
wire     [ID_BITS-1:0] s3_wid     ; 

   // write response    
wire                   s3_bvalid  ; 
wire                   s3_bready  ; 
wire           [ 1 :0] s3_bresp   ; 
wire     [ID_BITS-1:0] s3_bid     ; 


   //
   // read interface
   //
   
   // read address 
wire                   s3_arvalid; 
wire                   s3_arready; 
wire  [ADRS_BITS-1: 0] s3_araddr ; 
wire     [ID_BITS-1:0] s3_arid   ; 
wire    [LEN_BITS-1:0] s3_arlen  ; 
wire           [ 2: 0] s3_arsize ; 
wire           [ 1: 0] s3_arburst; 
wire           [ 3: 0] s3_arcache; 
wire           [ 1: 0] s3_arlock ; 
wire           [ 2: 0] s3_arprot ; 
wire           [ 3: 0] s3_arqos  ; 

   // read data
wire                   s3_rvalid ; 
wire                   s3_rready ; 
wire   [DATA_BITS-1:0] s3_rdata  ; 
wire                   s3_rlast  ; 
wire     [ID_BITS-1:0] s3_rid    ; 
wire           [ 1 :0] s3_rresp  ; 

 
   /*****************\
    *               *
    *  MASTER PORT  *
    *               *
   \*****************/
   
   // ID is bigger here 

   //
   // write interface
   //
   
wire                   m_awvalid ; 
wire                   m_awready ; 
wire   [ADRS_BITS-1:0] m_awaddr  ; 
wire    [LEN_BITS-1:0] m_awlen   ; 
wire            [ 2:0] m_awsize  ; 
wire     [ID_BITS+1:0] m_awid    ; 
wire            [ 1:0] m_awburst ; 
wire            [ 3:0] m_awcache ; 
wire            [ 1:0] m_awlock  ; 
wire            [ 2:0] m_awprot  ; 
wire            [ 3:0] m_awqos   ; 
                           
   // write data           
wire                   m_wvalid  ; 
wire                   m_wready  ; 
wire   [DATA_BITS-1:0] m_wdata   ; 
wire            [ 3:0] m_wstrb   ; 
wire                   m_wlast   ; 
wire     [ID_BITS+1:0] m_wid     ; 

   // write response    
wire                   m_bvalid  ; 
wire                   m_bready  ; 
wire           [ 1 :0] m_bresp   ; 
wire     [ID_BITS+1:0] m_bid     ; 

   //
   // read interface
   //
   
   // read address 
wire                   m_arvalid; 
wire                   m_arready; 
wire  [ADRS_BITS-1: 0] m_araddr ; 
wire     [ID_BITS+1:0] m_arid   ; 
wire    [LEN_BITS-1:0] m_arlen  ; 
wire           [ 2: 0] m_arsize ; 
wire           [ 1: 0] m_arburst; 
wire           [ 3: 0] m_arcache; 
wire           [ 1: 0] m_arlock ; 
wire           [ 2: 0] m_arprot ; 
wire           [ 3: 0] m_arqos  ; 

   // read data
wire                   m_rvalid ; 
wire                   m_rready ; 
wire   [DATA_BITS-1:0] m_rdata  ; 
wire                   m_rlast  ; 
wire     [ID_BITS+1:0] m_rid    ; 
wire           [ 1 :0] m_rresp  ; 

reg        [  1:0] control;

integer  b0,b1,b2,b3,d0,d1,d2,d3;
integer  v0,v1,v2,v3,r0,r1,r2,r3;
integer  q,port,exp_port;


   initial
   begin

      clk         = 1'b0;
      reset_n     = 1'b0;
      run         = 1'b0;
   
      control     = 2'b0;
      
      // Fill memory with test pattern
      for (v0=0; v0<(1<<L2MEM_DEPTH); v0=v0+1)
         axi_dpm32_0.write(v0,v0);
      
      # (CLK_PERIOD*5);
      reset_n = 1'b1;
      # (CLK_PERIOD*5);
      
      // Each master uses 1/4 of the memory 
      // As I uses bursts of up to 4 units
      // I have make sure I don't go over the boundary
      // into the next area so modulo a bit smaller 
      
      write_data_check_task;
      
      read_data_check_task;
      
      write_round_robin_check_task;

      read_round_robin_check_task;
      
       
      # (CLK_PERIOD*50);
      
      // If a test fails it stops at that point
      // Thus if we arrive here we have found no errors.
      // (Which is different from: there are no errors!!)
      $display("************************");
      $display("**                    **");
      $display("**    Test Passed     **");
      $display("**                    **");
      $display("************************");
      $stop;


      
   end

task run_and_check_task;
integer errors;
begin
   # (CLK_PERIOD*5);
   run = 1'b1;
   # (CLK_PERIOD*5);
   wait (done0 & done1 & done2 & done3);
   # (CLK_PERIOD*5);
   run = 1'b0;

   errors = 0;
   // Check memory with test pattern
   for (v0=0; v0<(1<<L2MEM_DEPTH); v0=v0+1)
   begin
      if (axi_dpm32_0.read(v0)!==v0)
      begin
         $display("%m mem check failed at location 0x%08x",v0);
         errors = errors + 1;
      end
   end
   if (errors==0)
      $display("%m @%0t check passed",$time);
   else
   begin
      if (errors==1)
         $display("1 error detected");
      else
         $display("%d errors detected",errors);
     $stop;
   end
   
   # (CLK_PERIOD*50);
end
endtask

axi_mux4rr
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) , 
      .ID_BITS   (ID_BITS)    // # ID bits slave ports
   ) // parameters
axi_mux4rr_0 (
      .clk       (clk),
      .reset_n   (reset_n),
   
   /******************\
    *                *
    *  SLAVE PORT 0  *
    *                *
   \******************/

  // write address 
   
      .s0_awvalid(s0_awvalid),
      .s0_awready(s0_awready),
      .s0_awaddr (s0_awaddr),
      .s0_awlen  (s0_awlen),
      .s0_awsize (s0_awsize),
      .s0_awid   (s0_awid),
      .s0_awburst(s0_awburst),
      .s0_awcache(s0_awcache),
      .s0_awlock (s0_awlock),
      .s0_awprot (s0_awprot),
      .s0_awqos  (s0_awqos),
                           
   // write data           
      .s0_wvalid (s0_wvalid),
      .s0_wready (s0_wready),
      .s0_wdata  (s0_wdata),
      .s0_wstrb  (s0_wstrb),
      .s0_wlast  (s0_wlast),
      .s0_wid    (s0_wid),

   // write response    
      .s0_bvalid (s0_bvalid),
      .s0_bready (s0_bready),
      .s0_bresp  (s0_bresp),
      .s0_rresp  (s0_rresp),
      .s0_bid    (s0_bid),


   //
   // read interface
   //
   
   // read address 
      .s0_arvalid(s0_arvalid),
      .s0_arready(s0_arready),
      .s0_araddr (s0_araddr),
      .s0_arid   (s0_arid),
      .s0_arlen  (s0_arlen),
      .s0_arsize (s0_arsize),
      .s0_arburst(s0_arburst),
      .s0_arcache(s0_arcache),
      .s0_arlock (s0_arlock),
      .s0_arprot (s0_arprot),
      .s0_arqos  (s0_arqos),

   // read data
      .s0_rvalid (s0_rvalid),
      .s0_rready (s0_rready),
      .s0_rdata  (s0_rdata),
      .s0_rlast  (s0_rlast),
      .s0_rid    (s0_rid),

  /******************\
   *                *
   *  SLAVE PORT 1  *
   *                *
  \******************/
   
  // write address 
  
      .s1_awvalid(s1_awvalid),
      .s1_awready(s1_awready),
      .s1_awaddr (s1_awaddr),
      .s1_awlen  (s1_awlen),
      .s1_awsize (s1_awsize),
      .s1_awid   (s1_awid),
      .s1_awburst(s1_awburst),
      .s1_awcache(s1_awcache),
      .s1_awlock (s1_awlock),
      .s1_awprot (s1_awprot),
      .s1_awqos  (s1_awqos),
                           
   // write data           
      .s1_wvalid (s1_wvalid),
      .s1_wready (s1_wready),
      .s1_wdata  (s1_wdata),
      .s1_wstrb  (s1_wstrb),
      .s1_wlast  (s1_wlast),
      .s1_wid    (s1_wid),

   // write response    
      .s1_bvalid (s1_bvalid),
      .s1_bready (s1_bready),
      .s1_bresp  (s1_bresp),
      .s1_rresp  (s1_rresp),
      .s1_bid    (s1_bid),


   //
   // read interface
   //
   
   // read address 
      .s1_arvalid(s1_arvalid),
      .s1_arready(s1_arready),
      .s1_araddr (s1_araddr),
      .s1_arid   (s1_arid),
      .s1_arlen  (s1_arlen),
      .s1_arsize (s1_arsize),
      .s1_arburst(s1_arburst),
      .s1_arcache(s1_arcache),
      .s1_arlock (s1_arlock),
      .s1_arprot (s1_arprot),
      .s1_arqos  (s1_arqos),

   // read data
      .s1_rvalid (s1_rvalid),
      .s1_rready (s1_rready),
      .s1_rdata  (s1_rdata),
      .s1_rlast  (s1_rlast),
      .s1_rid    (s1_rid),
   
   /******************\
   *                *
   *  SLAVE PORT 2  *
   *                *
  \******************/
   
  // write address 
  
      .s2_awvalid(s2_awvalid),
      .s2_awready(s2_awready),
      .s2_awaddr (s2_awaddr),
      .s2_awlen  (s2_awlen),
      .s2_awsize (s2_awsize),
      .s2_awid   (s2_awid),
      .s2_awburst(s2_awburst),
      .s2_awcache(s2_awcache),
      .s2_awlock (s2_awlock),
      .s2_awprot (s2_awprot),
      .s2_awqos  (s2_awqos),
                           
   // write data           
      .s2_wvalid (s2_wvalid),
      .s2_wready (s2_wready),
      .s2_wdata  (s2_wdata),
      .s2_wstrb  (s2_wstrb),
      .s2_wlast  (s2_wlast),
      .s2_wid    (s2_wid),

   // write response    
      .s2_bvalid (s2_bvalid),
      .s2_bready (s2_bready),
      .s2_bresp  (s2_bresp),
      .s2_rresp  (s2_rresp),
      .s2_bid    (s2_bid),


   //
   // read interface
   //
   
   // read address 
      .s2_arvalid(s2_arvalid),
      .s2_arready(s2_arready),
      .s2_araddr (s2_araddr),
      .s2_arid   (s2_arid),
      .s2_arlen  (s2_arlen),
      .s2_arsize (s2_arsize),
      .s2_arburst(s2_arburst),
      .s2_arcache(s2_arcache),
      .s2_arlock (s2_arlock),
      .s2_arprot (s2_arprot),
      .s2_arqos  (s2_arqos),

   // read data
      .s2_rvalid (s2_rvalid),
      .s2_rready (s2_rready),
      .s2_rdata  (s2_rdata),
      .s2_rlast  (s2_rlast),
      .s2_rid    (s2_rid),
   
   
   /******************\
   *                *
   *  SLAVE PORT 3  *
   *                *
  \******************/
   
  // write address 
  
      .s3_awvalid(s3_awvalid),
      .s3_awready(s3_awready),
      .s3_awaddr (s3_awaddr),
      .s3_awlen  (s3_awlen),
      .s3_awsize (s3_awsize),
      .s3_awid   (s3_awid),
      .s3_awburst(s3_awburst),
      .s3_awcache(s3_awcache),
      .s3_awlock (s3_awlock),
      .s3_awprot (s3_awprot),
      .s3_awqos  (s3_awqos),
                           
   // write data           
      .s3_wvalid (s3_wvalid),
      .s3_wready (s3_wready),
      .s3_wdata  (s3_wdata),
      .s3_wstrb  (s3_wstrb),
      .s3_wlast  (s3_wlast),
      .s3_wid    (s3_wid),

   // write response    
      .s3_bvalid (s3_bvalid),
      .s3_bready (s3_bready),
      .s3_bresp  (s3_bresp),
      .s3_rresp  (s3_rresp),
      .s3_bid    (s3_bid),


   //
   // read interface
   //
   
   // read address 
      .s3_arvalid(s3_arvalid),
      .s3_arready(s3_arready),
      .s3_araddr (s3_araddr),
      .s3_arid   (s3_arid),
      .s3_arlen  (s3_arlen),
      .s3_arsize (s3_arsize),
      .s3_arburst(s3_arburst),
      .s3_arcache(s3_arcache),
      .s3_arlock (s3_arlock),
      .s3_arprot (s3_arprot),
      .s3_arqos  (s3_arqos),

   // read data
      .s3_rvalid (s3_rvalid),
      .s3_rready (s3_rready),
      .s3_rdata  (s3_rdata),
      .s3_rlast  (s3_rlast),
      .s3_rid    (s3_rid),
 

///////////////////////////////////////////////////////////   
 
   /*******************\
    *                 *
    *  MASTER PORT 0  *
    *                 *
   \*******************/
   
   // ID is bigger here 

   //
   // write interface
   //
   
   // write address 
   
      .m_awvalid (m_awvalid),
      .m_awready (m_awready),
      .m_awaddr  (m_awaddr),
      .m_awlen   (m_awlen),
      .m_awsize  (m_awsize),
      .m_awid    (m_awid),
      .m_awburst (m_awburst),
      .m_awcache (m_awcache),
      .m_awlock  (m_awlock),
      .m_awprot  (m_awprot),
      .m_awqos   (m_awqos),
                           
   // write data           
      .m_wvalid  (m_wvalid),
      .m_wready  (m_wready),
      .m_wdata   (m_wdata),
      .m_wstrb   (m_wstrb),
      .m_wlast   (m_wlast),
      .m_wid     (m_wid),

   // write response    
      .m_bvalid  (m_bvalid),
      .m_bready  (m_bready),
      .m_bresp   (m_bresp),
      .m_rresp   (m_rresp),
      .m_bid     (m_bid),


   //
   // read interface
   //
   
   // read address 
      .m_arvalid (m_arvalid),
      .m_arready (m_arready),
      .m_araddr  (m_araddr),
      .m_arid    (m_arid),
      .m_arlen   (m_arlen),
      .m_arsize  (m_arsize),
      .m_arburst (m_arburst),
      .m_arcache (m_arcache),
      .m_arlock  (m_arlock),
      .m_arprot  (m_arprot),
      .m_arqos   (m_arqos),

   // read data
      .m_rvalid  (m_rvalid),
      .m_rready  (m_rready),
      .m_rdata   (m_rdata),
      .m_rlast   (m_rlast),
      .m_rid     (m_rid)
      
   );

   
   
axi_test_master
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 
   ) // parameters
axi_test_master0 (

      .clk    (clk),
      .reset_n(reset_n),
      .run    (run),
      .done   (done0),
      
   // write address
      .awvalid(s0_awvalid),
      .awready(s0_awready),
      .awaddr (s0_awaddr),
      .awlen  (s0_awlen),
      .awsize (s0_awsize),
      .awid   (s0_awid),
      .awburst(s0_awburst),
   
      .awcache(s0_awcache),
      .awlock (s0_awlock),
      .awprot (s0_awprot),
      .awqos  (s0_awqos),
                           
   // write data           
      .wvalid (s0_wvalid),
      .wready (s0_wready),
      .wdata  (s0_wdata),
      .wstrb  (s0_wstrb),
      .wlast  (s0_wlast),
      .wid    (s0_wid),

   // write response    
      .bvalid (s0_bvalid),
      .bready (s0_bready),
      .bresp  (s0_bresp),
      .rresp  (s0_rresp),
      .bid    (s0_bid),

   //........................
   
   // read address
      .arvalid(s0_arvalid),
      .arready(s0_arready),
      .araddr (s0_araddr),
      .arlen  (s0_arlen),
      .arsize (s0_arsize),
      .arid   (s0_arid),
      .arburst(s0_arburst),
   
      .arcache(s0_arcache),
      .arlock (s0_arlock),
      .arprot (s0_arprot),
      .arqos  (s0_arqos),
 
   // read data
      .rvalid (s0_rvalid),
      .rready (s0_rready),
      .rdata  (s0_rdata),
      .rlast  (s0_rlast),
      .rid    (s0_rid)
 
       );

   
axi_test_master
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 
   ) // parameters
axi_test_master1 (
      .clk    (clk),
      .reset_n(reset_n),
      .run    (run),
      .done   (done1),

   // write address
      .awvalid(s1_awvalid),
      .awready(s1_awready),
      .awaddr (s1_awaddr),
      .awlen  (s1_awlen),
      .awsize (s1_awsize),
      .awid   (s1_awid),
      .awburst(s1_awburst),
   
      .awcache(s1_awcache),
      .awlock (s1_awlock),
      .awprot (s1_awprot),
      .awqos  (s1_awqos),
                           
   // write data           
      .wvalid (s1_wvalid),
      .wready (s1_wready),
      .wdata  (s1_wdata),
      .wstrb  (s1_wstrb),
      .wlast  (s1_wlast),
      .wid    (s1_wid),

   // write response    
      .bvalid (s1_bvalid),
      .bready (s1_bready),
      .bresp  (s1_bresp),
      .rresp  (s1_rresp),
      .bid    (s1_bid),

   //........................
   
   // read address
      .arvalid(s1_arvalid),
      .arready(s1_arready),
      .araddr (s1_araddr),
      .arlen  (s1_arlen),
      .arsize (s1_arsize),
      .arid   (s1_arid),
      .arburst(s1_arburst),
   
      .arcache(s1_arcache),
      .arlock (s1_arlock),
      .arprot (s1_arprot),
      .arqos  (s1_arqos),
      
   // read data
      .rvalid (s1_rvalid),
      .rready (s1_rready),
      .rdata  (s1_rdata),
      .rlast  (s1_rlast),
      .rid    (s1_rid)
      
       );

   
axi_test_master
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 
   ) // parameters
axi_test_master2 (

      .clk    (clk),
      .reset_n(reset_n),
      .run    (run),
      .done   (done2),
      
   // write address
      .awvalid(s2_awvalid),
      .awready(s2_awready),
      .awaddr (s2_awaddr),
      .awlen  (s2_awlen),
      .awsize (s2_awsize),
      .awid   (s2_awid),
      .awburst(s2_awburst),
   
      .awcache(s2_awcache),
      .awlock (s2_awlock),
      .awprot (s2_awprot),
      .awqos  (s2_awqos),
                           
   // write data           
      .wvalid (s2_wvalid),
      .wready (s2_wready),
      .wdata  (s2_wdata),
      .wstrb  (s2_wstrb),
      .wlast  (s2_wlast),
      .wid    (s2_wid),

   // write response    
      .bvalid (s2_bvalid),
      .bready (s2_bready),
      .bresp  (s2_bresp),
      .rresp  (s2_rresp),
      .bid    (s2_bid),

   //........................
   
   // read address
      .arvalid(s2_arvalid),
      .arready(s2_arready),
      .araddr (s2_araddr),
      .arlen  (s2_arlen),
      .arsize (s2_arsize),
      .arid   (s2_arid),
      .arburst(s2_arburst),
   
      .arcache(s2_arcache),
      .arlock (s2_arlock),
      .arprot (s2_arprot),
      .arqos  (s2_arqos),
 
   // read data
      .rvalid (s2_rvalid),
      .rready (s2_rready),
      .rdata  (s2_rdata),
      .rlast  (s2_rlast),
      .rid    (s2_rid)
 
       );
   
axi_test_master
   #(
      .ADRS_BITS (ADRS_BITS),
      .DATA_BITS (DATA_BITS),
      .LEN_BITS  (LEN_BITS) ,
      .ID_BITS   (ID_BITS)  ,
                                 // Depth of the queues (FIFOs)
      .AQ_DEPTH  (AQ_DEPTH) ,  // Max 1K addresses
      .DQ_DEPTH  (DQ_DEPTH)    // Max 64K data 
   ) // parameters
axi_test_master3 (

      .clk    (clk),
      .reset_n(reset_n),
      .run    (run),
      .done   (done3),
      
   // write address
      .awvalid(s3_awvalid),
      .awready(s3_awready),
      .awaddr (s3_awaddr),
      .awlen  (s3_awlen),
      .awsize (s3_awsize),
      .awid   (s3_awid),
      .awburst(s3_awburst),
   
      .awcache(s3_awcache),
      .awlock (s3_awlock),
      .awprot (s3_awprot),
      .awqos  (s3_awqos),
                           
   // write data           
      .wvalid (s3_wvalid),
      .wready (s3_wready),
      .wdata  (s3_wdata),
      .wstrb  (s3_wstrb),
      .wlast  (s3_wlast),
      .wid    (s3_wid),

   // write response    
      .bvalid (s3_bvalid),
      .bready (s3_bready),
      .bresp  (s3_bresp),
      .rresp  (s3_rresp),
      .bid    (s3_bid),

   //........................
   
   // read address
      .arvalid(s3_arvalid),
      .arready(s3_arready),
      .araddr (s3_araddr),
      .arlen  (s3_arlen),
      .arsize (s3_arsize),
      .arid   (s3_arid),
      .arburst(s3_arburst),
   
      .arcache(s3_arcache),
      .arlock (s3_arlock),
      .arprot (s3_arprot),
      .arqos  (s3_arqos),
 
   // read data
      .rvalid (s3_rvalid),
      .rready (s3_rready),
      .rdata  (s3_rdata),
      .rlast  (s3_rlast),
      .rid    (s3_rid)
 
       );

axi_dpm32
   #(
      .ADRS_BITS   (ADRS_BITS)  ,
      .DATA_BITS   (DATA_BITS)  ,
      .LEN_BITS    (LEN_BITS)   ,
      .ID_BITS     (ID_BITS+2)  ,
                                     // 2-Log depth of the memory in data bits above 
      .L2MEM_DEPTH (L2MEM_DEPTH)
   ) // parameters
axi_dpm32_0 (

      .clk    (clk),
      .reset_n(reset_n),
   
   //
   // AXI port 
   //
   
   // write address 
   
      .awvalid(m_awvalid),
      .awready(m_awready),
      .awaddr (m_awaddr),
      .awlen  (m_awlen),
      .awsize (m_awsize),
      .awid   (m_awid),
      .awburst(m_awburst),
                           
   // write data           
      .wvalid (m_wvalid),
      .wready (m_wready),
      .wdata  (m_wdata),
      .wstrb  (m_wstrb),
      .wlast  (m_wlast),
      .wid    (m_wid),

   // write response    
      .bvalid (m_bvalid),
      .bready (m_bready),
      .bresp  (m_bresp),
      .rresp  (m_rresp),
      .bid    (m_bid),


   //
   // read interface
   //
   
   // read address 
      .arvalid(m_arvalid),
      .arready(m_arready),
      .araddr (m_araddr),
      .arid   (m_arid),
      .arlen  (m_arlen),
      .arsize (m_arsize),
      .arburst(m_arburst),

   // read data
      .rvalid (m_rvalid),
      .rready (m_rready),
      .rdata  (m_rdata),
      .rlast  (m_rlast),
      .rid    (m_rid) 
   );

       
   // Generate clock. 
   initial
   begin
      clk = 1'b0;
      forever
         #(CLK_PERIOD/2) clk = ~clk;
   end

// ---------------------------
//
// write data test
//
// --------------------------
task write_data_check_task;
begin
      // Go through all combinations of delay 0-3 and burst 1-3
            
      for (b0=1; b0<4; b0=b0+1)
      begin // master 0 burst 1..3
         for (b1=1; b1<4; b1=b1+1)
         begin
            for (b2=1; b2<4; b2=b2+1)
            begin
               for (b3=1; b3<4; b3=b3+1)
               begin
               
                  for (d0=0; d0<4; d0=d0+1)
                  begin // master 0 delay 0..3
                     for (d1=0; d1<4; d1=d1+1)
                     begin
                        for (d2=0; d2<4; d2=d2+1)
                        begin
                           for (d3=0; d3<4; d3=d3+1)
                           begin
   
   fork
      // Write to queues in parallel 
      begin   
         v0 = 32'h0000+($random % 32'h03FC);
         axi_test_master0.q_wsync(
                v0<<2, // address;
                   b0, // length;
                   32, // size;
                    0, // id;
                    1, // burst;
                    0, // delay_random;
                   d0, // delay;
                   v0, // data;
                 4'hF, // strobes;
            b0==1?1:0, // last;
                    0, // delay_random;
                   d0  // delay;
                   );
         v0 = v0 + 1;
         for (r0=1; r0<b0;r0=r0+1)
         begin
            axi_test_master0.q_wdata(
               v0, 4'hF,
               r0==b0-1?1:0,0,0,2
               );
            v0 = v0 + 1;
         end
      end
      begin
         v1 = 32'h0400+($random % 32'h03FC);
         axi_test_master1.q_wsync(
                 v1<<2, // address;
                    b1, // length;
                    32, // size;
                     1, // id;
                     1, // burst;
                     0, // delay_random;
                    d1, // delay;
                    v1, // data;
                  4'hF, // strobes;
             b1==1?1:0, // last;
                     0, // delay_random;
                    d1  // delay;
                    );
         v1 = v1 + 1;
         for (r1=1; r1<b1;r1=r1+1)
         begin
            axi_test_master1.q_wdata(v1, 4'hF,
               r1==b1-1?1:0,1,0,2
               );
            v1 = v1 + 1;
         end
      end
      begin
         v2 = 32'h0800+($random % 32'h03FC);
         axi_test_master2.q_wsync(
                v2<<2, // address;
                   b2, // length;
                   32, // size;
                    2, // id;
                    1, // burst;
                    0, // delay_random;
                   d2, // delay;
                   v2, // data;
                 4'hF, // strobes;
            b2==1?1:0, // last;
                    0, // delay_random;
                   d2  // delay;
                   );
         v2 = v2 + 1;
         for (r2=1; r2<b2;r2=r2+1)
         begin
            axi_test_master2.q_wdata(v2, 4'hF,
               r2==b2-1?1:0,2,0,2
               );
             v2 = v2 + 1;
          end
      end
      begin
         v3 = 32'h0C00+($random % 32'h03FC);
         axi_test_master3.q_wsync(
                v3<<2, // address;
                   b3, // length;
                   32, // size;
                    3, // id;
                    1, // burst;
                    0, // delay_random;
                   d3, // delay;
                   v3, // data;
                 4'hF, // strobes;
            b3==1?1:0, // last;
                    0, // delay_random;
                   d3  // delay;
                   );
         v3 = v3 + 1;
         for (r3=1; r3<b3;r3=r3+1)
         begin
            axi_test_master3.q_wdata(v3, 4'hF,
               r3==b3-1?1:0,3,0,2
               );
             v3 = v3 + 1;
          end
      end
   join
                           end
                        end
                     end
                  end
         
                  // Can not queue all tests so:
                  run_and_check_task;
               end
            end
         end
      end
      
   $display("%m @%0t write data check passed",$time);
      
end      
endtask // write_data_check_task



// ---------------------------
//
// read data test
//
// --------------------------
task read_data_check_task;
begin
    
      // Loop through all combinations of
      // burst =1..4 and delay = 0..3
      // Read address is random 
      for (b0=1; b0<4; b0=b0+1)
      begin // master 0 burst 1..3
         for (b1=1; b1<4; b1=b1+1)
         begin
            for (b2=1; b2<4; b2=b2+1)
            begin
               for (b3=1; b3<4; b3=b3+1)
               begin
               
                  for (d0=0; d0<4; d0=d0+1)
                  begin // master 0 delay 0..3
                     for (d1=0; d1<4; d1=d1+1)
                     begin
                        for (d2=0; d2<4; d2=d2+1)
                        begin
                           for (d3=0; d3<4; d3=d3+1)
                           begin

   fork
      // Write to queues in parallel 
      begin  // join task 0  
         v0 = 32'h0000 + ($random % 32'h0550);
         // Queue up a read (address & expected data)
         // (synced reads do not exist)
         axi_test_master0.q_ardata(
                v0<<2, // address;
                   b0, // length;
                   32, // size;
                    0, // id;
                    1, // bursttype;
                    0, // delay_random;
                   d0, // delay;
                   v0, // rdata;
            b0==1?1:0, // rlast;
                    0, // rdelay_random;
                   d0, // rdelay;
                    0  // rdelay mode 
                   );
         // Next value 
         v0 = v0 + 1;
         // If we have a burst (b0>1) queue more expected data                         
         for (r0=1; r0<b0;r0=r0+1)
         begin
            // args= data,last,id,delay_random,delay,delay_mode
            axi_test_master0.q_rdata(v0, 
               r0==b0-1?1:0,0,0,d0,0
               );
            v0 = v0 + 1;
         end
      end
      begin  // join task 1
         v1 = 32'h0400 + ($random % 32'h03FC);
         axi_test_master1.q_ardata(
                v1<<2, // address;
                   b1, // length;
                   32, // size;
                    1, // id;
                    1, // bursttype;
                    0, // delay_random;
                   d1, // delay;
                   v1, // rdata;
            b1==1?1:0, // rlast;
                    0, // rdelay_random;
                   d1, // rdelay;
                    0  // rdelay_mode;
                   );
         v1 = v1 + 1;
         for (r1=1; r1<b1;r1=r1+1)
         begin
            // args= data,last,id,delay_random,delay,delay_mode
            axi_test_master1.q_rdata(v1, 
               r1==b1-1?1:0,1,0,d1,0
               );
            v1 = v1 + 1;
         end
      end
      begin  // join task 2
         v2 = 32'h0800 + ($random % 32'h03FC);
         axi_test_master2.q_ardata(
                v2<<2, // address;
                   b2, // length;
                   32, // size;
                    2, // id;
                    1, // bursttype;
                    0, // delay_random;
                   d2, // delay;
                   v2, // rdata;
            b2==1?1:0, // rlast;
                    0, // rdelay_random;
                   d2, // rdelay;
                    0  // rdelay_mode;
                  );
         v2 = v2 + 1;
         for (r2=1; r2<b2;r2=r2+1)
         begin
            // args= data,last,id,delay_random,delay,delay_mode
            axi_test_master2.q_rdata(v2, 
                r2==b2-1?1:0,2,0,d2,0
                );
            v2 = v2 + 1;
         end
      end // join task 2
      begin  // join task 3
         v3 = 32'h0C00 + ($random % 32'h03FC);
         axi_test_master3.q_ardata(
                v3<<2, // address;
                   b3, // length;
                   32, // size;
                    3, // id;
                    1, // bursttype;
                    0, // delay_random;
                   d3, // delay;
                   v3, // rdata;
            b3==1?1:0, // rlast;
                    0, // rdelay_random;
                   d3, // rdelay;
                    0  // rdelay_mode;
                  );
         v3 = v3 + 1;
         for (r3=1; r3<b3;r3=r3+1)
         begin
            // args= data,last,id,delay_random,delay,delay_mode
            axi_test_master3.q_rdata(v3, 
                r3==b3-1?1:0,3,0,d3,0
                );
            v3 = v3 + 1;
         end
      end // join task 3
   join

                           end // for d3
                        end // for d2
                     end // for d1
                  end // for d0
                  
                  // Run now to prevent axi master queues overflow 
                  # (CLK_PERIOD*5);
                  run = 1'b1;
                  # (CLK_PERIOD*5);
                  wait (done0 & done1 & done2 & done3);
                  # (CLK_PERIOD*5);
                  run = 1'b0;
                  # (CLK_PERIOD*50);
               
               end // for b3
            end // for b2
         end // for b1
      end // for b0
      
   $display("%m @%0t read data check passed",$time);
      
end       
endtask // read_data_check_task




//
// Check write port round robin is working
//
task write_round_robin_check_task;
begin
   // Ful request, no delays all channels
   // Should write in order 0, 1, 2, 3, 0, 1, 2..
   // starting with whom ever was last
   
   v0 = 32'h0000;
   v1 = 32'h0400;
   v2 = 32'h0800;
   v3 = 32'h0C00;
   // Bursts of 3 
   b0=3;
   b1=3;
   b2=3;
   b3=3;
   
   // we have ~0x400 = 1024 memory locations per master
   // Burst of three so max 341 writes
   // If 100 pass I believe it is OK 
   for (q=0; q<100; q=q+1)
   begin
   
      fork
         // Write to queues in parallel 
         begin  // write master0 queue
            axi_test_master0.q_wsync(
                   v0<<2, // address;
                      b0, // length;
                      32, // size;
                       0, // id;
                       1, // burst;
                       0, // delay_random;
                       0, // delay;
                      v0, // data;
                    4'hF, // strobes;
               b0==1?1:0, // last;
                       0, // delay_random;
                       0  // delay;
                      );
            v0 = v0 + 1;
            for (r0=1; r0<b0;r0=r0+1)
            begin
               axi_test_master0.q_wdata(
                  v0,           // data;        
                  4'hF,         // strobes;     
                  r0==b0-1?1:0, // last;        
                  0,            // id;          
                  0,            // delay_random;
                  0             // delay;       
                  );
               v0 = v0 + 1;
            end
         end
         begin // write master1 queue
            axi_test_master1.q_wsync(
                    v1<<2, // address;
                       b1, // length;
                       32, // size;
                        1, // id;
                        1, // burst;
                        0, // delay_random;
                        0, // delay;
                       v1, // data;
                     4'hF, // strobes;
                b1==1?1:0, // last;
                        0, // delay_random;
                        0  // delay;
                       );
            v1 = v1 + 1;
            for (r1=1; r1<b1;r1=r1+1)
            begin
               axi_test_master1.q_wdata(v1, 4'hF,
                  r1==b1-1?1:0,
                  1,
                  0,0
                  );
               v1 = v1 + 1;
            end
         end
         begin // write master2 queue
            axi_test_master2.q_wsync(
                   v2<<2, // address;
                      b2, // length;
                      32, // size;
                       2, // id;
                       1, // burst;
                       0, // delay_random;
                       0, // delay;
                      v2, // data;
                    4'hF, // strobes;
               b2==1?1:0, // last;
                       0, // delay_random;
                       0  // delay;
                      );
            v2 = v2 + 1;
            for (r2=1; r2<b2;r2=r2+1)
            begin
               axi_test_master2.q_wdata(v2, 4'hF,
                  r2==b2-1?1:0,
                  2,
                  0,0
                  );
                v2 = v2 + 1;
             end
         end
          begin // write master3 queue
            axi_test_master3.q_wsync(
                   v3<<2, // address;
                      b3, // length;
                      32, // size;
                       3, // id;
                       1, // burst;
                       0, // delay_random;
                       0, // delay;
                      v3, // data;
                    4'hF, // strobes;
               b3==1?1:0, // last;
                       0, // delay_random;
                       0  // delay;
                      );
            v3 = v3 + 1;
            for (r3=1; r3<b3;r3=r3+1)
            begin
               axi_test_master3.q_wdata(v3, 4'hF,
                  r3==b3-1?1:0,
                  3,
                  0,0
                  );
                v3 = v3 + 1;
             end
         end
      join
   end // for q 
   
   
   # (CLK_PERIOD*5);
   run = 1'b1;
   
   //
   // Determine input port processing order
   //
   
   // Pick up the first one 
   wait( (s0_awvalid & s0_awready) |
         (s1_awvalid & s1_awready) | 
         (s2_awvalid & s2_awready) | 
         (s3_awvalid & s3_awready) ) ;
   if (s0_awvalid & s0_awready) port=0;
   if (s1_awvalid & s1_awready) port=1;
   if (s2_awvalid & s2_awready) port=2;
   if (s3_awvalid & s3_awready) port=3;
   @(posedge clk) ; 
   
   // check round robin operation
   for (q=1; q<300; q=q+1)
   begin
      @(posedge clk)
      if ((s0_awvalid & s0_awready) |
          (s1_awvalid & s1_awready) | 
          (s2_awvalid & s2_awready) | 
          (s3_awvalid & s3_awready)
         )
      begin
         exp_port = (port + 1) % 4; 
         if (s0_awvalid & s0_awready) port=0;
         if (s1_awvalid & s1_awready) port=1;
         if (s2_awvalid & s2_awready) port=2;
         if (s3_awvalid & s3_awready) port=3;
         if ( exp_port != port )
         begin
            $display("%m @%0t: write mux priority error, Have %d expected %d",
                      $time,port,exp_port);
            #1 $stop;
         end
         
      end
   end
   
   # (CLK_PERIOD*5);
   wait (done0 & done1 & done2);
   # (CLK_PERIOD*5);
   run = 1'b0;
   # (CLK_PERIOD*50);
   
   $display("%m @%0t write round robin check passed",$time);

end

endtask // write_round_robin_check_task      


//
// Check read port round robin is working
//
task read_round_robin_check_task;
begin
   // Ful request, no delays all channels
   // Should read from 0,1,2
   // starting with whom ever was last
   
   v0 = 32'h0000;
   v1 = 32'h0400;
   v2 = 32'h0800;
   v3 = 32'h0C00;
   // Bursts of 3 
   b0=3;
   b1=3;
   b2=3;
   b3=3;
   
   // we have ~0x400 = 1024 memory locations per master
   // Burst of three so max 341 writes
   // If 100 pass I believe it is OK 
   for (q=0; q<100; q=q+1)
   begin
   
      fork
         // Write to queues in parallel 
         begin  // write master0 queue  
            // Queue up a read (address & expected data)
            // (synced reads do not exist)
            axi_test_master0.q_ardata(
                   v0<<2, // address;
                      b0, // length;
                      32, // size;
                       0, // id;
                       1, // bursttype;
                       0, // delay_random;
                       0, // delay;
                      v0, // rdata;
               b0==1?1:0, // rlast;
                       0, // rdelay_random;
                       0, // rdelay;
                       0  // rdelay mode 
                      );
            // Next value 
            v0 = v0 + 1;
            // If we have a burst (b0>1) queue more expected data                         
            for (r0=1; r0<b0;r0=r0+1)
            begin
               // args= data,last,id,delay_random,delay,delay_mode
               axi_test_master0.q_rdata(v0, 
                  r0==b0-1?1:0,0,0,0,0
                  );
               v0 = v0 + 1;
            end
         end
         begin  // write master1 queue
            axi_test_master1.q_ardata(
                   v1<<2, // address;
                      b1, // length;
                      32, // size;
                       1, // id;
                       1, // bursttype;
                       0, // delay_random;
                       0, // delay;
                      v1, // rdata;
               b1==1?1:0, // rlast;
                       0, // rdelay_random;
                       0, // rdelay;
                       0  // rdelay_mode;
                      );
            v1 = v1 + 1;
            for (r1=1; r1<b1;r1=r1+1)
            begin
               // args= data,last,id,delay_random,delay,delay_mode
               axi_test_master1.q_rdata(v1, 
                  r1==b1-1?1:0,1,0,0,0
                  );
               v1 = v1 + 1;
            end
         end
         begin  // write master2 queue
            axi_test_master2.q_ardata(
                   v2<<2, // address;
                      b2, // length;
                      32, // size;
                       2, // id;
                       1, // bursttype;
                       0, // delay_random;
                       0, // delay;
                      v2, // rdata;
               b2==1?1:0, // rlast;
                       0, // rdelay_random;
                       0, // rdelay;
                       0  // rdelay_mode;
                     );
            v2 = v2 + 1;
            for (r2=1; r2<b2;r2=r2+1)
            begin
               // args= data,last,id,delay_random,delay,delay_mode
               axi_test_master2.q_rdata(v2, 
                   r2==b2-1?1:0,2,0,0,0
                   );
               v2 = v2 + 1;
            end
         end // join task 2
         begin  // write master3 queue
            axi_test_master3.q_ardata(
                   v3<<2, // address;
                      b3, // length;
                      32, // size;
                       3, // id;
                       1, // bursttype;
                       0, // delay_random;
                       0, // delay;
                      v3, // rdata;
               b3==1?1:0, // rlast;
                       0, // rdelay_random;
                       0, // rdelay;
                       0  // rdelay_mode;
                     );
            v3 = v3 + 1;
            for (r3=1; r3<b3;r3=r3+1)
            begin
               // args= data,last,id,delay_random,delay,delay_mode
               axi_test_master3.q_rdata(v3, 
                   r3==b3-1?1:0,3,0,0,0
                   );
               v3 = v3 + 1;
            end
         end // join task 2
      join
   end // for q 
   
   
   # (CLK_PERIOD*5);
   run = 1'b1;
   
   //
   // Determine input port processing order
   //
   
   // Pick up the first one 
   wait( (s0_arvalid & s0_arready) |
         (s1_arvalid & s1_arready) | 
         (s2_arvalid & s2_arready) | 
         (s3_arvalid & s3_arready) ) ;
   if (s0_arvalid & s0_arready) port=0;
   if (s1_arvalid & s1_arready) port=1;
   if (s2_arvalid & s2_arready) port=2;
   if (s3_arvalid & s3_arready) port=3;
   @(posedge clk) ; 
   
   // check round robin operation
   for (q=1; q<300; q=q+1)
   begin
      @(posedge clk)
      if ( (s0_arvalid & s0_arready) |
           (s1_arvalid & s1_arready) | 
           (s2_arvalid & s2_arready) | 
           (s3_arvalid & s3_arready)
         )
      begin
         exp_port = (port + 1) % 4;
         if (s0_arvalid & s0_arready) port=0;
         if (s1_arvalid & s1_arready) port=1;
         if (s2_arvalid & s2_arready) port=2;
         if (s3_arvalid & s3_arready) port=3;
         if ( exp_port != port )
         begin
            $display("%m @%0t: read mux priority error, Have %d expected %d",
                      $time,port,exp_port);
            #1 $stop;
         end
         
      end
   end
   
   # (CLK_PERIOD*5);
   wait (done0 & done1 & done2);
   # (CLK_PERIOD*5);
   run = 1'b0;
   # (CLK_PERIOD*50);
   $display("%m @%0t read round robin check passed",$time);

end

endtask // read_round_robin_check_task      



endmodule
